/*
 File Name: GOC.h
 Date: Nov 16, 2010
*/

 #ifndef GOC_h
 #define GOC_h

 #include "./source/PlatformSpecific/inc/ErrorReport.h"
 #include "./source/inc/TimeGOC.h"
 #include "./source/inc/InputEngine.h"

 /* Add new include files here */
 #include "./source/PlatformSpecific/inc/Sprite.h"
 #include "./source/inc/MathGOC.h"
 #include "./source/PlatformSpecific/inc/DeviceInput.h"

 class GOC
 {
     public:
         
         // Initialize the developer's game.
         virtual void Initialize();
         
         // Updates the developer's game state.
         virtual void Update(TimeGOC *timeGOC_p, InputEngine *input_p);
         virtual void IndepedentUpdate(TimeGOC *timeGOC_p, InputEngine *input_p);
         
         // Ceans up the developer's game.
         virtual void Destroy();
         
         // This is how you interact with the GOC.
         // 
         // Output:
         //         Returns the Game Object Creator instance pointer.
         static GOC *goc_i();

         // Get the window's width and height.
         int GetWindowWidth();
         int GetWindowHeight();
         
         // Start the setup of the Game Object Creator.
         #ifdef _WIN32
             void LoadGOC(HINSTANCE &hinstance_p);
         #else
             void LoadGOC();
         #endif
         
         // Clean up the Game Object Creator.
         void UnloadGOC();
         
         ErrorReport *GetErrorReport();        

     private:
     
         GOC();
         ~GOC();
         GOC(GOC const&){};
         GOC &operator=(GOC const&){};
                 
     private:

         /* Add private variables here. */
         Sprite *ball_m;
         
         Sprite *playerOne_m;
         Sprite *playerTwo_m;
         
         int maxPlayerPosition_m;
         
         int maxBallX_m;
         int maxBallY_m;
         
         float ballVelocityX_m;
         float ballVelocityY_m;
         
         int ballSpeed_m;
         float ballAngle_m;       
 };

 #endif

